function FdPageInfo(id) {
  this.id = id;
  this.url = "";
  this.title = "";
  this.refresh = 0;
  this.customImage = "";
  this.customBackground = "";
  this.openIn = "";
}

var FdPrefs = {
  prefs: Components.classes["@mozilla.org/preferences-service;1"]
         .getService(Components.interfaces.nsIPrefService)
         .getBranch("extensions.fastdial."),

  getPageInfo: function(id) {
    var pageInfo = this.getObjectPref(id) || new FdPageInfo(id);
    pageInfo.url = decodeURI(pageInfo.url);
    pageInfo.customImage = decodeURI(pageInfo.customImage);
    pageInfo.id = id; // Support legacy preferences
    return pageInfo;
  },

  savePageInfo: function(pageInfo) {
    if (pageInfo.url) {
      pageInfo = FdUtils.clone(pageInfo);
      pageInfo.url = encodeURI(pageInfo.url);
      pageInfo.customImage = encodeURI(pageInfo.customImage);
      this.setObjectPref(pageInfo.id, pageInfo);
    }
    else this.clearPageInfo(pageInfo.id);
  },

  clearPageInfo: function(id) {
    this.clearPref(id);
  },

  clearPref: function(name) {
    try {
      this.prefs.deleteBranch(name);
    } catch(e) {}
  },

  getBoolPref: function(name) {
    try {
      return this.prefs.getBoolPref(name);
    } catch(e) {
      return false;
    }
  },

  setBoolPref: function(name, value) {
    this.prefs.setBoolPref(name, value);
  },

  getIntPref: function(name) {
    try {
      return this.prefs.getIntPref(name);
    } catch(e) {
      return 0;
    }
  },

  setIntPref: function(name, value) {
    this.prefs.setIntPref(name, value);
  },

  getCharPref: function(name) {
    try {
      return this.prefs.getComplexValue(name,
        Components.interfaces.nsISupportsString).data;
    } catch(e) {
      return null;
    }
  },

  setCharPref: function(name, value) {
    this.clearPref(name); // Remove legacy preference

    var str = Components.classes["@mozilla.org/supports-string;1"]
              .createInstance(Components.interfaces.nsISupportsString);
    str.data = value;
    this.prefs.setComplexValue(name,
      Components.interfaces.nsISupportsString, str);
  },

  setObjectPref: function(name, object) {
    this.setCharPref(name, FdUtils.toJSON(object));
  },

  getObjectPref: function(name) {
    return eval(this.getCharPref(name));
  }
}
